<template>
	<div class="chat">
		<h1>chat</h1>
		<div class="messages">
			<ul>
				<li v-for="msg in messages">
				<div class="msg">{{ msg.msg }}</div>
				<div class="date">{{ msg.date }}</div>
				</li>
			</ul>
		</div>
		<form>
			<input type="text" v-model="newMsg">
			<button @click.prevent="sendMsg">Send Message</button>	
		</form>

	</div>
</template>

<script>
	import chat from '../utils/chat'
	import backend from '../utils/backend'
	const API_URL = backend.API_URL

	var socket = null
	export default {
		name: 'chat',
		data() {
			return {
				newMsg: '',
				messages: []
			}
		},
		methods: {
			sendMsg() {
				this.messages.push(this.newMsg)
				socket.emit('fromClient', {msg: this.newMsg, date: Date()})
				this.newMsg = ''
			}
		},
		mounted() {
			socket = this.$io(API_URL)
			socket.on('fromServer', (data) => {
				this.messages.push(data.data)
				var msgEl = document.querySelector('.messages')
			})

			chat.getChat(this, 'ch1003')
			.catch((err) => console.log(err))
			.then((chat) => {

				this.messages = chat.messages
			})
		}
	}
</script>

<style lang="scss">
	.chat li {
		list-style: none;
	}

	.messages {
		height: 300px;
		/*width: 400px;*/
		overflow-y: scroll;

		.msg {

		}
		.date {
			color: #bbb;
			font-size: .7em;
		}
	}
</style>